;;;;;;;;===== Get Boundaries by TEXTs =====;;;;
(defun KM:BND ( pt0 / pt)
   (setq pt pt0)
   (command "_.-boundary" "_a" "_i" "_n" "" "" "_non" pt "")
 (princ)
)

(defun KM:getJtexts( rm / )
; (setq ss (ssget ":S" (list '(0 . "TEXT"))))
;
  (setq tx1 rm)
;
(if (= (cdr (assoc 72 (entget tx1))) 0) (setq a11 (assoc 10 (entget tx1)))
  (setq a11 (assoc 11 (entget tx1))) ; point of justification for text
); if
  (setq jp (list (cadr a11) (caddr a11) 0.0)) ; list ( Px Py 0.0)
;
  (print jp)
); defun

(defun KM:area_lwp ( / e id area m2area )
  (setq e (entget (entlast)))
  (setq id (cdr (assoc -1 e)))
  (setq area (vlax-curve-getArea id))
  (setq m2area (* 1.0e-06 area)) ; mm2 -> m2
  (setq _M2 (strcat ": " (rtos m2area 2 2) "m2")) ; roundup 0.0#
  (princ)
); defun

(defun KM:RmAreaX ( _M2 / txt_lst rmname exist_m2 rmarea)
  (setq txt_lst (entget tx1))
  (setq rmname (cdr (assoc 1 txt_lst)))
  (if (/= nil (setq exist_m2 (vl-string-search ":" rmname))); if it exist rmarea, update rmarea.
     (progn
       (setq rmname
       (substr rmname 1 exist_m2))); progn
   ); if
  (setq rmarea (cons 1 (strcat rmname _M2)))
  (entmod (subst rmarea (assoc 1 txt_lst) txt_lst))
  (princ)
); defun


;;----- TXTs to CSV file -----
(defun KM:csv ( pts / )
  (setq p1 (car pts) p2 (cadr pts))
  (setq _LISTXT ( ))
  (setq txts (ssget "_W" p1 p2 '((0 . "text"))))
  (setq len (sslength txts))
  (setq n 0)
;Write csv file
  (setq d (rtos (getvar "CDATE") 2 6))
  (setq csvfile (strcat "c:/temp/" d ".csv"))
  (setq file_w (open csvfile "w"))
  (setq header "No.\tRoomName\t=sum(c2:c30)")
  (write-line header file_w)
;
(setq _AREA 0.0)
(repeat len
	(setq txt_lst (entget (ssname txts n)))
	(setq str (cdr (assoc 1 txt_lst)))
;; Extract AREA	from str
    (setq loc_split (+ 3 (vl-string-search ":" str)))
	(setq _AREA (+ _AREA 
	(atof (substr str loc_split (- (strlen str) (+ loc_split 1))))))
;;
	(setq rm_area_m2 (vl-string-subst "\t" ":" str))
	(setq rm_area (vl-string-subst "" "m2" rm_area_m2))
	(setq n_rm_area (strcat (itoa n) "\t" rm_area))

	(write-line n_rm_area file_w)
	(setq n (1+ n))
);repeat 
(setq style_ (cdr (assoc 7 (entget (ssname txts 0)))))
(setq size_ (* 1.5 (cdr (assoc 40 (entget (ssname txts 0))))))
(progn ; find mid point
	(setq x (/ (- (car p2) (car p1)) 2.0))
	(setq y (/ (- (cadr p2) (cadr p1)) 2.0))
	(setq p3 (list (+ (car p1) x) (+ (cadr p1) y)))
)
;(princ (setq _TOTAL (strcat "\n" (getvar "CLAYER") "_TOTAL AREA: " (rtos _AREA 2 2) "m2\n")))
(princ (setq _TOTAL (strcat "\nTOTAL AREA: " (rtos _AREA 2 2) "m2\t(" (rtos (* _AREA 0.3025) 2 1) "PY)\n")))
;(prompt "\n>> Specify Insertion point of the Total Area...\n")
(entmake (list (cons 0 "TEXT") (cons 1 _TOTAL) (cons 7 style_) (cons 10 p3) (cons 11 p3) (cons 40 size_) (cons 72 4)))
(princ _AREA)
;
(close file_w)
(princ "\n")
(princ)
);defun

;;----- Main get Boundaries by single Text -----

(defun c:aaa( / ) ;Auto careate LWPolyline for AREA
(setq jpt (KM:getJtexts))
(KM:BND jpt)
(KM:area_lwp)
(KM:RmAreaX _M2)

)

;;----- Main Multi get Boundaries by Texts -----

(defun c:ara( / pt1 pt2 ) ;Auto careate LWPolyline for AREA
(setq ss
 (ssget "_w" (setq pt1 (getpoint "\nPick the first point")) (setq pt2 (getcorner pt1 "\nPick a corner"))
 (list '(0 . "TEXT")))
)
(setq pts (list pt1 pt2))
(repeat (setq i (sslength ss))
  (setq rm (ssname ss (setq i (1- i))))

  (setq jpt (KM:getJtexts rm))
  (KM:BND jpt)
  (KM:area_lwp)
  (KM:RmAreaX _M2)
)
(princ pts)

  (KM:csv pts)

(startapp "explorer /e, c:\\temp\\")
)